#include "mTips.h"

// RichEdit Procedure
LRESULT CALLBACK RichProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
	switch(msg)
	{
		case WM_CHAR:
		{
			if(wParam == 8)
			{
				char szNewLine[256];
				char * pszLine;

				GetTextRange(hwnd, szNewLine);
				pszLine = strrchr(szNewLine, '$');

				if(!pszLine)
				{
					if(IsWindow(mTip))
						DestroyWindow(mTip);
					break;
				}

				if(!strrchr(pszLine, '('))
					DestroyWindow(mTip);

			}

			if(wParam == 40)
			{

				char szLine[256];
				char *szWord = NULL;

				if(!GetTextRange(hwnd, szLine))
					break;

				if(!strchr(szLine, '$'))
					szWord = szLine;
				else
					szWord = strrchr(szLine, '$');

				if(IsKeyword(szWord))
				{
					if(IsWindow(mTip))
						DestroyWindow(mTip);

					CreateTooltip(szWord);
				}
			}

			if((wParam == 13) | (wParam == 41) & (IsWindow(mTip)))
				DestroyWindow(mTip);
		}
		break;

		default:
			break;
	}

	return CallWindowProc(mOrigProc, hwnd, msg, wParam, lParam);
}

// Hook Procedure
LRESULT CALLBACK HookProc(int nCode, WPARAM wParam, LPARAM lParam)
{
	switch(nCode)
	{
		case HCBT_ACTIVATE:
		{
			if(nCalls == 1)
			{
				HWND hActive = (HWND)wParam;
				char szWinText[21];

				GetWindowText(hActive, szWinText, 20);
			
				if(strcmp(szWinText, "mIRC Scripts Editor") == 0)
				{
					nCalls++;

					mEditor = hActive;

					mRichEdit = GetDlgItem(mEditor, 300);

					mOrigProc = (WNDPROC)SetWindowLong(mRichEdit, GWL_WNDPROC, (LONG)RichProc);
				}
			}
		}
		break;

		case HCBT_DESTROYWND:
			if(((HWND)wParam == mEditor) & (nCalls > 1))
				nCalls = 1;
		break;
	}

	return 0;
}

mFunc(HookEditor)
{
	if(bHooked) 
	{
		mReturn("E_ALREADY_HOOKED"); 
	}
	else
	{
		mHook = SetWindowsHookEx(WH_CBT, HookProc, GetModuleHandle(NULL), GetCurrentThreadId());

		InitCommonControls();

		bHooked = TRUE;

		mReturn("S_HOOKED");
	}

	return 3;
}

// Remove the window hook
mFunc(UnhookEditor)
{
	if(bHooked)
	{
		EditorCleanup();

		mReturn("S_UNHOOKED");
	}
	else
		mReturn("E_NO_HOOK_SET");

	return 3;
}

// Make sure mIRC keeps the DLL loaded
void WINAPI LoadDll(LOADINFO *li)
{
	dVersion = li->mVersion;
}

// Stop mIRC unloading the DLL after 10 minutes
int WINAPI UnloadDll(int mTimeout)
{
	if(mTimeout == 1)
		return 0;

	return 1;
}

// Clean up when the DLL is unloaded
BOOL WINAPI DllMain(HINSTANCE hInst, DWORD dwReason, LPVOID lpVoid)
{
	if((dwReason == DLL_PROCESS_DETACH) & (bHooked))
		EditorCleanup();

	return TRUE;
}
